function ttpad(am)
{
	if (am < 10)
	{
		return "0" + am;
	}
	return am;
}

(function ( $ ) {
 
	var defaults = {
		onDateChanged: null,
		includeRange: true,
		includeCompare: true,
		includeContexts: true,
		contexts: [[1,"Actual",true]]
	}
	
	var settings = {};
	
	var currentprofile = "1";
	var currentmoment = "";
	var comparemoment = "";
	var compareprofile = "1";
	var rangemoment = "";
	
	buildExpression = function() {
		var vv = ""+currentprofile;
		if ((currentmoment == "") && (comparemoment == "")) return vv + "+" + (new Date().getTimezoneOffset());
		
		if (currentmoment != "") 
			vv += ";" + currentmoment.year() + "/" + (currentmoment.month()+1) + "/" + currentmoment.date() + "/" + currentmoment.hour() + "/" + currentmoment.minutes();
		
		if (rangemoment != "")
		{
			vv += "-" + rangemoment.year() + "/" + (rangemoment.month()+1) + "/" + rangemoment.date() + "/" + rangemoment.hour() + "/" + rangemoment.minutes();
		}
		
		if (comparemoment != "")
		{
			vv += "^" + compareprofile + ";" + comparemoment.year() + "/" + (comparemoment.month()+1) + "/" + comparemoment.date() + "/" + comparemoment.hour() + "/" + comparemoment.minutes();
		}
		vv += "z" + (new Date().getTimezoneOffset())
		return vv;
	}
	
	var methods = {
	
		golive: function () {
		
			return this.each( function () {
				if ($('.timetravel .range.display').css('display') != 'none')
				{
					$('.timetravel .range.display').fadeOut(500);
				}
				$('.timetravel .primary.display').html('<h1>LIVE</h1><h2>DATA</h2>');
				$('.timetravel .additional').fadeOut(500);
				
				currentmoment = "";
				if (settings.onDateChange != null)
				{
					settings.onDateChange(buildExpression());
				}
			});
		},
		
		togglerange: function () {
		
			return this.each( function () {
				if ($('.timetravel .range.display').css('display') != 'none')
				{
					$('.timetravel .additional').fadeOut(500);
					$('.timetravel .range.display').fadeOut(500);
					rangemoment = "";
					if (settings.onDateChange != null)
					{
						settings.onDateChange(buildExpression());
					}
				}
				else
				{
					$('.timetravel .range.display').html('Select Range').fadeIn(500);
					$('.timetravel').timetravel('rangelist');
				}
			});
		},
		
		togglecontext: function () {
		
			return this.each( function () {
				var clist = "";
				for(var x=0;x<settings.contexts.length;x++)
				{
					clist += '<li><a href="#" onclick="$(\'.timetravel\').timetravel(\'setcontext\',' + settings.contexts[x][0] + ',\'' + settings.contexts[x][1] + '\',' + settings.contexts[x][2] + ');return false;">' + settings.contexts[x][1] + '</a>';
				}
				$('.timetravel .additional').css('top','0px').css('left','20px').html('\
					<ul><li class="header">Context</li>' + clist + '<li><a href="#" onclick="$(\'.timetravel .additional\').fadeOut(500); return false;">Cancel</a></li></ul>\
				').fadeIn(500);
			});
		},
		
		togglecomparecontext: function () {
		
			return this.each( function () {
				var clist = "";
				for(var x=0;x<settings.contexts.length;x++)
				{
					clist += '<li><a href="#" onclick="$(\'.timetravel\').timetravel(\'setcomparecontext\',' + settings.contexts[x][0] + ',\'' + settings.contexts[x][1] + '\',' + settings.contexts[x][2] + ');return false;">' + settings.contexts[x][1] + '</a>';
				}
				$('.timetravel .additional').css('top','0px').css('left','20px').html('\
					<ul><li class="header">Context</li>' + clist + '<li><a href="#" onclick="$(\'.timetravel .additional\').fadeOut(500); return false;">Cancel</a></li></ul>\
				').fadeIn(500);
			});
		},
		
		togglecompare: function () {
		
			return this.each( function () {
				if ($('.timetravel .secondary.display').css('display') != 'none')
				{
					$('.timetravel .secondary.display').delay(250).fadeOut(500);
					$('.timetravel .secondary.context').fadeOut(500);
					
					if (settings.onDateChange != null)
					{
						settings.onDateChange(buildExpression());
					}
				}
				else
				{
					$('.timetravel .secondary.display').html('Choose Time').fadeIn(500);
					$('.timetravel .secondary.context').delay(500).fadeIn(500);
					$('.timetravel').timetravel('comparelist');
				}
			});
		},
		
		comparelist: function () {
		
			return this.each( function () {
				$('.timetravel .additional').css('top','110px').css('left','20px').html('\
					<ul><li class="header">Compare Against</li><li><a href="#" onclick="$(\'.timetravel\').timetravel(\'eventlist\');return false;">Event</a></li><li><a href="#" onclick="$(\'.timetravel\').timetravel(\'recentlist\');return false;">Recent</a></li><li><input type="text" class="dtime"/></li><li><a href="#" onclick="$(\'.timetravel .additional\').fadeOut(500); return false;">Cancel</a></li></ul>\
				').fadeIn(500);
				
				$('.timetravel .dtime').datetimepicker({
					onClose: function (dp,$input) {
						//var mn = dp.getMinutes();
						comparemoment = new moment({year: dp.getYear() + 1900, month: dp.getMonth()+1,day: dp.getDate(), hour: dp.getHours(), minute: dp.getMinutes()});
						$('.timetravel .secondary.display').html('<h1>' + dp.getHours() + ":" + ttpad(dp.getMinutes()) + '</h1><h2>' + ttpad(dp.getDate()) + '/' + ttpad(dp.getMonth()+1) + '/' + (dp.getYear() + 1900) + '</h2>');
						$('.timetravel .additional').fadeOut(500);
						if (settings.onDateChange != null)
						{
							settings.onDateChange(buildExpression());
						}
					}
				});
			});
		},
		
		calendar: function () {
		
			return this.each( function () {
				$('.timetravel .additional').css('top','50px').css('left','50px').html('\
					<ul><li>Calendar</li><li><input type="text" class="dtime"/></li><li><a href="#" onclick="$(\'.timetravel\').timetravel(\'golive\');">Live</a></li><li><a href="#" onclick="$(\'.timetravel .additional\').fadeOut(500); return false;">Close</a></li></ul>\
				').fadeIn(500);
				$('.timetravel .dtime').datetimepicker({
					onClose: function (dp,$input) {
						//var mn = dp.getMinutes();
						
						currentmoment = new moment({year: dp.getYear() + 1900, month: dp.getMonth()+1,day: dp.getDate(), hour: dp.getHours(), minute: dp.getMinutes()});
						$('.timetravel .primary.display').html('<h1>' + dp.getHours() + ":" + ttpad(dp.getMinutes()) + '</h1><h2>' + ttpad(dp.getDate()) + '/' + ttpad(dp.getMonth()+1) + '/' + (dp.getYear() + 1900) + '</h2>');
						$('.timetravel .additional').fadeOut(500);
						if (settings.onDateChange != null)
						{
							settings.onDateChange(buildExpression());
						}
					}
				});
			});
		},
		
		rangelist: function () {
		
			return this.each( function () {
				$('.timetravel .additional').css('top','20px').css('left','125px').html('\
						<ul><li class="header">Range / To</li><li><a href="#" onclick="$(\'.timetravel\').timetravel(\'eventlist\');return false;">Event</a></li><li><a href="#" onclick="$(\'.timetravel\').timetravel(\'recentlist\');return false;">Recent</a></li><li><input type="text" class="dtime"/></li><li><a href="#" onclick="$(\'.timetravel .additional\').fadeOut(500); return false;">Cancel</a></li></ul>\
					').fadeIn(500);
					
				$('.timetravel .dtime').datetimepicker({
					onClose: function (dp,$input) {
						//var mn = dp.getMinutes();
						
						if (currentmoment == "")
						{
							currentmoment = moment();
							$('.timetravel .primary.display').html('<h1>' + currentmoment.hours() + ":" + ttpad(currentmoment.minutes()) + '</h1><h2>' + ttpad(currentmoment.date()) + '/' + ttpad(currentmoment.month()+1) + '/' + (currentmoment.year()) + '</h2>');
						}
						rangemoment = new moment({year: dp.getYear() + 1900, month: dp.getMonth()+1,day: dp.getDate(), hour: dp.getHours(), minute: dp.getMinutes()});
						$('.timetravel .range.display').html('<h1>' + dp.getHours() + ":" + ttpad(dp.getMinutes()) + '</h1><h2>' + ttpad(dp.getDate()) + '/' + ttpad(dp.getMonth()+1) + '/' + (dp.getYear() + 1900) + '</h2>');
						$('.timetravel .additional').fadeOut(500);
						if (settings.onDateChange != null)
						{
							settings.onDateChange(buildExpression());
						}
					}
				});
			});
		},
		
		eventlist: function () {
		
			return this.each( function () {
				$('.timetravel .additional').html('\
						<input type="text" name="query"/><ul class="eventlist"></div>\
						<a class="btn btn-default" href="#" onclick="$(\'.timetravel .additional\').fadeOut(500); return false;">Cancel</a>\
					');
			});
		},
		
		setcontext: function (id,name,supportslive) {
		
			return this.each( function () {
				$('.timetravel .additional').fadeOut(500);
				currentprofile=id;
				$('.timetravel .primary.context').html(name);
				
				if ((supportslive == false) && (currentmoment == ""))
				{
					currentmoment = moment();
					$('.timetravel .primary.display').html('<h1>' + currentmoment.hours() + ":" + ttpad(currentmoment.minutes()) + '</h1><h2>' + ttpad(currentmoment.date()) + '/' + ttpad(currentmoment.month()+1) + '/' + (currentmoment.year()) + '</h2>');
				}
				
				if (settings.onDateChange != null)
				{
					settings.onDateChange(buildExpression());
				}
			});
		},
		
		setcomparecontext: function (id,name,supportslive) {
		
			return this.each( function () {
				$('.timetravel .additional').fadeOut(500);
				compareprofile=id;
				$('.timetravel .secondary.context').html(name);
				
				if (settings.onDateChange != null)
				{
					settings.onDateChange(buildExpression());
				}
			});
		},
		
		currentMode: function () {
		
			if (currentmoment != "")
			{
				if (comparemoment != "")
				{
					if (rangemoment != "")
						return 'Compare Range';
					else
						return 'Compare Instant';
				}
				else
				{
					if (rangemoment != "")
						return 'Range';
					else
						return 'Instant';
				}
			}
			else
				return 'Live';
		},
		
		currentStart: function () {
			if (currentmoment != "")
			{
				return currentmoment;
			}
			return "";
		},
		
		currentEnd: function () {
			if (rangemoment != "")
			{
				return rangemoment;
			}
			return "";
		},
		
		currentContext: function () {
			if (currentprofile != "")
			{
				return currentprofile;
			}
			return "";
		},
		
		compareStart: function () {
			if (comparemoment != "")
			{
				return comparemoment;
			}
			return "";
		},
		
		compareProfile: function () {
			if (compareprofile != "")
			{
				return compareprofile;
			}
			return "";
		},
		
		init: function(options) {
			return this.each( function () {
				//alert('Initialing!');
				settings = $.extend({},defaults, options );
				var ob = $(this);
				ob.addClass('timetravel');
				var controls = '<a href="#"><div class="primary base display">\
					<h1>LIVE</h1>\
					<h2>DATA</h2>\
				</div></a>\
				<a class="primary context topbutton" href="#">\
					Actual\
				</a>\
				<a class="compare topbutton" href="#">\
					Compare</a>\
				</a>\
				<a class="range sidebutton" href="#">\
					Range\
				<a>\
				<div class="range display" style="display: none;">\
					<h2>1/1/2015</h2>\
					<h3>6:14PM</h3>\
				</div>\
				<div class="secondary display base" style="display: none;">\
					<h2>1/1/2015</h2>\
					<h3>3:14PM</h3>\
				</div>\
				<div class="secondary frame display" style="display: none;">\
					<h2>1/1/2015</h2>\
					<h3>4:14PM</h3>\
				</div>\
				<div class="secondary context topbutton" style="display: none;">\
					Actual\
				</div>\
				<div class="primary datetime" style="display: none; z-index: 100;">\
					<a href="#" class="btn btn-default chooselive" id="livebutton" style="width: 100%;">Live Data</a>\
					<input type="text" id="fromtime" name="fromtime"/>\
					<a href="#" class="btn btn-default chooserange" id="rangebutton" style="width: 100%;">Show Date/Time</a>\
				</div>\
				<div class="primaryframe datetime" style="display: none; z-index: 100; position: absolute; width: 350px;">\
					<input type="text" id="totime" name="totime"/>\
					<a href="#" class="btn btn-default chooserange" id="rangebuttont" style="width: 100%;">Show Date/Time</a>\
				</div>\
				<div class="additional" style="display: none;">\
				</div>';
				
				ob.html(controls);
				
				if (settings.includeContexts == false)
				{
					$('.timetravel .context').hide();
				}
				if (settings.includeCompare == false)
				{
					$('.timetravel .secondary').hide();
					$('.timetravel .compare').hide();
				}
				if (settings.includeRange == false)
				{
					$('.timetravel .range').hide();
				}
				
				$('.timetravel .primary.display').on('click',function (evt) {
					evt.preventDefault();
					$(this).timetravel('calendar');
				});
				
				$('.timetravel .primary.context.topbutton').on('click',function (evt) {
					evt.preventDefault();
					$(this).timetravel('togglecontext');
				});
				
				$('.timetravel .secondary.context.topbutton').on('click',function (evt) {
					evt.preventDefault();
					$(this).timetravel('togglecomparecontext');
				});
				
				$('.timetravel .compare.topbutton').on('click',function (evt) {
					evt.preventDefault();
					$(this).timetravel('togglecompare');
				});
				
				$('.timetravel .range.sidebutton').on('click',function (evt) {
					evt.preventDefault();
					$(this).timetravel('togglerange');
				});
				
				$('.timetravel .range.display').on('click',function (evt) {
					$('.timetravel').timetravel('rangelist');
				});
				
				$('.timetravel .secondary.display').on('click',function (evt) {
					$('.timetravel').timetravel('comparelist');
				});
				
				$('.timetravel .fromtime').datetimepicker({
					inline: true,
					step: 5,
					onChangeDateTime: function (dp, $input) {
						from_date = $input.val();
					}
				});

				$('.timetravel .totime').datetimepicker({
					inline: true,
					step: 5,
					onChangeDateTime: function (dp, $input) {
						to_date = $input.val();
					}
				});
			});
		}
	};
	
    $.fn.timetravel = function( action ) {
        if (methods[action]) {
			return methods[action].apply(this, Array.prototype.slice.call(arguments, 1));
		} else if (typeof action === 'object' || ! action) {
			return methods.init.apply(this, arguments);
		} else {
			$.error( 'Method ' +  action + ' does not exist on jQuery.pluginname' );
		}    
    };
 
}( jQuery ));